/* service.c generated by valac 0.12.1, the Vala compiler
 * generated from service.vala, do not modify */

/*
 * Copyright(C) 2010 Neil Jagdish Patel
 * Copyright(C) 2010 Canonical Ltd.
 *
 * This library is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License
 * version 3.0 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License version 3.0 for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library. If not, see
 * <http://www.gnu.org/licenses/>.
 *
 * Authored by Neil Jagdish Patel <neil.patel@canonical.com>
 * Authored by Ken VaDine <ken.vandine@canonical.com>
 */

#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <stdlib.h>
#include <string.h>
#include "gwibber.h"
#include <json-glib/json-glib.h>


#define TYPE_SERVICE_INTERFACE (service_interface_get_type ())
#define SERVICE_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SERVICE_INTERFACE, ServiceInterface))
#define IS_SERVICE_INTERFACE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SERVICE_INTERFACE))
#define SERVICE_INTERFACE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_SERVICE_INTERFACE, ServiceInterfaceIface))

typedef struct _ServiceInterface ServiceInterface;
typedef struct _ServiceInterfaceIface ServiceInterfaceIface;

#define TYPE_SERVICE_INTERFACE_PROXY (service_interface_proxy_get_type ())
typedef GDBusProxy ServiceInterfaceProxy;
typedef GDBusProxyClass ServiceInterfaceProxyClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_hash_table_unref0(var) ((var == NULL) ? NULL : (var = (g_hash_table_unref (var), NULL)))
#define _json_object_unref0(var) ((var == NULL) ? NULL : (var = (json_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _json_node_free0(var) ((var == NULL) ? NULL : (var = (json_node_free (var), NULL)))
#define _json_array_unref0(var) ((var == NULL) ? NULL : (var = (json_array_unref (var), NULL)))
#define __g_list_free__g_free0_0(var) ((var == NULL) ? NULL : (var = (_g_list_free__g_free0_ (var), NULL)))
#define _g_list_free0(var) ((var == NULL) ? NULL : (var = (g_list_free (var), NULL)))
#define __vala_GValue_free0(var) ((var == NULL) ? NULL : (var = (_vala_GValue_free (var), NULL)))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))

struct _ServiceInterfaceIface {
	GTypeInterface parent_iface;
	void (*Start) (ServiceInterface* self, GError** error);
	void (*Quit) (ServiceInterface* self, GError** error);
	void (*Refresh) (ServiceInterface* self, GError** error);
	void (*SendMessage) (ServiceInterface* self, const gchar* msg, GError** error);
	void (*Send) (ServiceInterface* self, const gchar* msg, GError** error);
	void (*Like) (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
	void (*Retweet) (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
	void (*PerformOp) (ServiceInterface* self, const gchar* op, GError** error);
	void (*UpdateIndicators) (ServiceInterface* self, const gchar* stream, GError** error);
	gchar* (*GetAvatarPath) (ServiceInterface* self, const gchar* url, GError** error);
	gchar* (*GetFeatures) (ServiceInterface* self, GError** error);
	gchar* (*GetServices) (ServiceInterface* self, GError** error);
	gchar* (*GetVersion) (ServiceInterface* self, GError** error);
};

struct _GwibberServicePrivate {
	ServiceInterface* service;
	GHashTable* services_table;
	GHashTable* service_table;
	GHashTable* features_table;
	GHashTable* feature_table;
	GwibberUtils* utils;
	GwibberMessages* messages;
};


static gpointer gwibber_service_parent_class = NULL;

GType service_interface_proxy_get_type (void) G_GNUC_CONST;
guint service_interface_register_object (void* object, GDBusConnection* connection, const gchar* path, GError** error);
GType service_interface_get_type (void) G_GNUC_CONST;
void service_interface_Start (ServiceInterface* self, GError** error);
void service_interface_Quit (ServiceInterface* self, GError** error);
void service_interface_Refresh (ServiceInterface* self, GError** error);
void service_interface_SendMessage (ServiceInterface* self, const gchar* msg, GError** error);
void service_interface_Send (ServiceInterface* self, const gchar* msg, GError** error);
void service_interface_Like (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
void service_interface_Retweet (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
void service_interface_PerformOp (ServiceInterface* self, const gchar* op, GError** error);
void service_interface_UpdateIndicators (ServiceInterface* self, const gchar* stream, GError** error);
gchar* service_interface_GetAvatarPath (ServiceInterface* self, const gchar* url, GError** error);
gchar* service_interface_GetFeatures (ServiceInterface* self, GError** error);
gchar* service_interface_GetServices (ServiceInterface* self, GError** error);
gchar* service_interface_GetVersion (ServiceInterface* self, GError** error);
static void service_interface_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters);
static void _dbus_handle_service_interface_loading_started (ServiceInterface* self, GVariant* parameters);
static void _dbus_handle_service_interface_loading_complete (ServiceInterface* self, GVariant* parameters);
static void _dbus_handle_service_interface_error (ServiceInterface* self, GVariant* parameters);
static void service_interface_proxy_Start (ServiceInterface* self, GError** error);
static void service_interface_proxy_Quit (ServiceInterface* self, GError** error);
static void service_interface_proxy_Refresh (ServiceInterface* self, GError** error);
static void service_interface_proxy_SendMessage (ServiceInterface* self, const gchar* msg, GError** error);
static void service_interface_proxy_Send (ServiceInterface* self, const gchar* msg, GError** error);
static void service_interface_proxy_Like (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
static void service_interface_proxy_Retweet (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error);
static void service_interface_proxy_PerformOp (ServiceInterface* self, const gchar* op, GError** error);
static void service_interface_proxy_UpdateIndicators (ServiceInterface* self, const gchar* stream, GError** error);
static gchar* service_interface_proxy_GetAvatarPath (ServiceInterface* self, const gchar* url, GError** error);
static gchar* service_interface_proxy_GetFeatures (ServiceInterface* self, GError** error);
static gchar* service_interface_proxy_GetServices (ServiceInterface* self, GError** error);
static gchar* service_interface_proxy_GetVersion (ServiceInterface* self, GError** error);
static void service_interface_proxy_service_interface_interface_init (ServiceInterfaceIface* iface);
static void _dbus_service_interface_Start (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Quit (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Refresh (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_SendMessage (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Send (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Like (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_Retweet (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_PerformOp (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_UpdateIndicators (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_GetAvatarPath (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_GetFeatures (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_GetServices (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void _dbus_service_interface_GetVersion (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation);
static void service_interface_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data);
static GVariant* service_interface_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data);
static gboolean service_interface_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data);
static void _dbus_service_interface_loading_started (GObject* _sender, gpointer* _data);
static void _dbus_service_interface_loading_complete (GObject* _sender, gpointer* _data);
static void _dbus_service_interface_error (GObject* _sender, const gchar* error_str, gpointer* _data);
static void _service_interface_unregister_object (gpointer user_data);
#define GWIBBER_SERVICE_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), GWIBBER_TYPE_SERVICE, GwibberServicePrivate))
enum  {
	GWIBBER_SERVICE_DUMMY_PROPERTY
};
#define GWIBBER_SERVICE_service_name "com.Gwibber.Service"
#define GWIBBER_SERVICE_service_path "/com/gwibber/Service"
static void _g_hash_table_remove_all_gdestroy_notify (void* data);
static void _g_free0_ (gpointer var);
static void _g_list_free__g_free0_ (GList* self);
static void _vala_GValue_free (GValue* self);
static GValue* _g_value_dup (GValue* self);
static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data);
static GObject * gwibber_service_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties);
void gwibber_utils_setup (GwibberUtils* self, const gchar* name, GError** error);
static void _gwibber_service_service_available_gwibber_utils_available (GwibberUtils* _sender, gboolean up, gpointer self);
static void _gwibber_service_on_loading_started_service_interface_loading_started (ServiceInterface* _sender, gpointer self);
static void _gwibber_service_on_loading_complete_service_interface_loading_complete (ServiceInterface* _sender, gpointer self);
static void _lambda4_ (const gchar* source, GwibberService* self);
static void __lambda4__service_interface_error (ServiceInterface* _sender, const gchar* error_str, gpointer self);
static void gwibber_service_finalize (GObject* obj);

static const GDBusArgInfo * const _service_interface_dbus_arg_info_Start_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Start_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Start = {-1, "Start", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Start_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Start_out)};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Quit_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Quit_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Quit = {-1, "Quit", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Quit_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Quit_out)};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Refresh_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Refresh_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Refresh = {-1, "Refresh", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Refresh_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Refresh_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_SendMessage_msg = {-1, "msg", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_SendMessage_in[] = {&_service_interface_dbus_arg_info_SendMessage_msg, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_SendMessage_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_SendMessage = {-1, "SendMessage", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_SendMessage_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_SendMessage_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_Send_msg = {-1, "msg", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Send_in[] = {&_service_interface_dbus_arg_info_Send_msg, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Send_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Send = {-1, "Send", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Send_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Send_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_Like_mid = {-1, "mid", "s"};
static const GDBusArgInfo _service_interface_dbus_arg_info_Like_account = {-1, "account", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Like_in[] = {&_service_interface_dbus_arg_info_Like_mid, &_service_interface_dbus_arg_info_Like_account, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Like_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Like = {-1, "Like", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Like_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Like_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_Retweet_mid = {-1, "mid", "s"};
static const GDBusArgInfo _service_interface_dbus_arg_info_Retweet_account = {-1, "account", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Retweet_in[] = {&_service_interface_dbus_arg_info_Retweet_mid, &_service_interface_dbus_arg_info_Retweet_account, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_Retweet_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_Retweet = {-1, "Retweet", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Retweet_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_Retweet_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_PerformOp_op = {-1, "op", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_PerformOp_in[] = {&_service_interface_dbus_arg_info_PerformOp_op, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_PerformOp_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_PerformOp = {-1, "PerformOp", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_PerformOp_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_PerformOp_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_UpdateIndicators_stream = {-1, "stream", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_UpdateIndicators_in[] = {&_service_interface_dbus_arg_info_UpdateIndicators_stream, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_UpdateIndicators_out[] = {NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_UpdateIndicators = {-1, "UpdateIndicators", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_UpdateIndicators_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_UpdateIndicators_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetAvatarPath_url = {-1, "url", "s"};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetAvatarPath_result = {-1, "result", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetAvatarPath_in[] = {&_service_interface_dbus_arg_info_GetAvatarPath_url, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetAvatarPath_out[] = {&_service_interface_dbus_arg_info_GetAvatarPath_result, NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_GetAvatarPath = {-1, "GetAvatarPath", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetAvatarPath_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetAvatarPath_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetFeatures_result = {-1, "result", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetFeatures_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetFeatures_out[] = {&_service_interface_dbus_arg_info_GetFeatures_result, NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_GetFeatures = {-1, "GetFeatures", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetFeatures_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetFeatures_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetServices_result = {-1, "result", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetServices_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetServices_out[] = {&_service_interface_dbus_arg_info_GetServices_result, NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_GetServices = {-1, "GetServices", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetServices_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetServices_out)};
static const GDBusArgInfo _service_interface_dbus_arg_info_GetVersion_result = {-1, "result", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetVersion_in[] = {NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_GetVersion_out[] = {&_service_interface_dbus_arg_info_GetVersion_result, NULL};
static const GDBusMethodInfo _service_interface_dbus_method_info_GetVersion = {-1, "GetVersion", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetVersion_in), (GDBusArgInfo **) (&_service_interface_dbus_arg_info_GetVersion_out)};
static const GDBusMethodInfo * const _service_interface_dbus_method_info[] = {&_service_interface_dbus_method_info_Start, &_service_interface_dbus_method_info_Quit, &_service_interface_dbus_method_info_Refresh, &_service_interface_dbus_method_info_SendMessage, &_service_interface_dbus_method_info_Send, &_service_interface_dbus_method_info_Like, &_service_interface_dbus_method_info_Retweet, &_service_interface_dbus_method_info_PerformOp, &_service_interface_dbus_method_info_UpdateIndicators, &_service_interface_dbus_method_info_GetAvatarPath, &_service_interface_dbus_method_info_GetFeatures, &_service_interface_dbus_method_info_GetServices, &_service_interface_dbus_method_info_GetVersion, NULL};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_loading_started[] = {NULL};
static const GDBusSignalInfo _service_interface_dbus_signal_info_loading_started = {-1, "LoadingStarted", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_loading_started)};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_loading_complete[] = {NULL};
static const GDBusSignalInfo _service_interface_dbus_signal_info_loading_complete = {-1, "LoadingComplete", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_loading_complete)};
static const GDBusArgInfo _service_interface_dbus_arg_info_error_error_str = {-1, "error_str", "s"};
static const GDBusArgInfo * const _service_interface_dbus_arg_info_error[] = {&_service_interface_dbus_arg_info_error_error_str, NULL};
static const GDBusSignalInfo _service_interface_dbus_signal_info_error = {-1, "Error", (GDBusArgInfo **) (&_service_interface_dbus_arg_info_error)};
static const GDBusSignalInfo * const _service_interface_dbus_signal_info[] = {&_service_interface_dbus_signal_info_loading_started, &_service_interface_dbus_signal_info_loading_complete, &_service_interface_dbus_signal_info_error, NULL};
static const GDBusPropertyInfo * const _service_interface_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _service_interface_dbus_interface_info = {-1, "com.Gwibber.Service", (GDBusMethodInfo **) (&_service_interface_dbus_method_info), (GDBusSignalInfo **) (&_service_interface_dbus_signal_info), (GDBusPropertyInfo **) (&_service_interface_dbus_property_info)};
static const GDBusInterfaceVTable _service_interface_dbus_interface_vtable = {service_interface_dbus_interface_method_call, service_interface_dbus_interface_get_property, service_interface_dbus_interface_set_property};

void service_interface_Start (ServiceInterface* self, GError** error) {
	SERVICE_INTERFACE_GET_INTERFACE (self)->Start (self, error);
}


void service_interface_Quit (ServiceInterface* self, GError** error) {
	SERVICE_INTERFACE_GET_INTERFACE (self)->Quit (self, error);
}


void service_interface_Refresh (ServiceInterface* self, GError** error) {
	SERVICE_INTERFACE_GET_INTERFACE (self)->Refresh (self, error);
}


void service_interface_SendMessage (ServiceInterface* self, const gchar* msg, GError** error) {
	SERVICE_INTERFACE_GET_INTERFACE (self)->SendMessage (self, msg, error);
}


void service_interface_Send (ServiceInterface* self, const gchar* msg, GError** error) {
	SERVICE_INTERFACE_GET_INTERFACE (self)->Send (self, msg, error);
}


void service_interface_Like (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	SERVICE_INTERFACE_GET_INTERFACE (self)->Like (self, mid, account, error);
}


void service_interface_Retweet (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	SERVICE_INTERFACE_GET_INTERFACE (self)->Retweet (self, mid, account, error);
}


void service_interface_PerformOp (ServiceInterface* self, const gchar* op, GError** error) {
	SERVICE_INTERFACE_GET_INTERFACE (self)->PerformOp (self, op, error);
}


void service_interface_UpdateIndicators (ServiceInterface* self, const gchar* stream, GError** error) {
	SERVICE_INTERFACE_GET_INTERFACE (self)->UpdateIndicators (self, stream, error);
}


gchar* service_interface_GetAvatarPath (ServiceInterface* self, const gchar* url, GError** error) {
	return SERVICE_INTERFACE_GET_INTERFACE (self)->GetAvatarPath (self, url, error);
}


gchar* service_interface_GetFeatures (ServiceInterface* self, GError** error) {
	return SERVICE_INTERFACE_GET_INTERFACE (self)->GetFeatures (self, error);
}


gchar* service_interface_GetServices (ServiceInterface* self, GError** error) {
	return SERVICE_INTERFACE_GET_INTERFACE (self)->GetServices (self, error);
}


gchar* service_interface_GetVersion (ServiceInterface* self, GError** error) {
	return SERVICE_INTERFACE_GET_INTERFACE (self)->GetVersion (self, error);
}


static void service_interface_base_init (ServiceInterfaceIface * iface) {
	static gboolean initialized = FALSE;
	if (!initialized) {
		initialized = TRUE;
		g_signal_new ("loading_started", TYPE_SERVICE_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
		g_signal_new ("loading_complete", TYPE_SERVICE_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
		g_signal_new ("error", TYPE_SERVICE_INTERFACE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__STRING, G_TYPE_NONE, 1, G_TYPE_STRING);
	}
}


GType service_interface_get_type (void) {
	static volatile gsize service_interface_type_id__volatile = 0;
	if (g_once_init_enter (&service_interface_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ServiceInterfaceIface), (GBaseInitFunc) service_interface_base_init, (GBaseFinalizeFunc) NULL, (GClassInitFunc) NULL, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType service_interface_type_id;
		service_interface_type_id = g_type_register_static (G_TYPE_INTERFACE, "ServiceInterface", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (service_interface_type_id, G_TYPE_OBJECT);
		g_type_set_qdata (service_interface_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) service_interface_proxy_get_type);
		g_type_set_qdata (service_interface_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "com.Gwibber.Service");
		g_type_set_qdata (service_interface_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) service_interface_register_object);
		g_once_init_leave (&service_interface_type_id__volatile, service_interface_type_id);
	}
	return service_interface_type_id__volatile;
}


G_DEFINE_TYPE_EXTENDED (ServiceInterfaceProxy, service_interface_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (TYPE_SERVICE_INTERFACE, service_interface_proxy_service_interface_interface_init) )
static void service_interface_proxy_class_init (ServiceInterfaceProxyClass* klass) {
	G_DBUS_PROXY_CLASS (klass)->g_signal = service_interface_proxy_g_signal;
}


static void _dbus_handle_service_interface_loading_started (ServiceInterface* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "loading-started");
}


static void _dbus_handle_service_interface_loading_complete (ServiceInterface* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	g_variant_iter_init (&_arguments_iter, parameters);
	g_signal_emit_by_name (self, "loading-complete");
}


static void _dbus_handle_service_interface_error (ServiceInterface* self, GVariant* parameters) {
	GVariantIter _arguments_iter;
	gchar* error_str = NULL;
	GVariant* _tmp8_;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp8_ = g_variant_iter_next_value (&_arguments_iter);
	error_str = g_variant_dup_string (_tmp8_, NULL);
	g_variant_unref (_tmp8_);
	g_signal_emit_by_name (self, "error", error_str);
	_g_free0 (error_str);
}


static void service_interface_proxy_g_signal (GDBusProxy* proxy, const gchar* sender_name, const gchar* signal_name, GVariant* parameters) {
	if (strcmp (signal_name, "LoadingStarted") == 0) {
		_dbus_handle_service_interface_loading_started ((ServiceInterface*) proxy, parameters);
	} else if (strcmp (signal_name, "LoadingComplete") == 0) {
		_dbus_handle_service_interface_loading_complete ((ServiceInterface*) proxy, parameters);
	} else if (strcmp (signal_name, "Error") == 0) {
		_dbus_handle_service_interface_error ((ServiceInterface*) proxy, parameters);
	}
}


static void service_interface_proxy_init (ServiceInterfaceProxy* self) {
}


static void service_interface_proxy_Start (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Start");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Quit (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Quit");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Refresh (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Refresh");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_SendMessage (ServiceInterface* self, const gchar* msg, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "SendMessage");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (msg));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Send (ServiceInterface* self, const gchar* msg, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Send");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (msg));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Like (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Like");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (mid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (account));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_Retweet (ServiceInterface* self, const gchar* mid, const gchar* account, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "Retweet");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (mid));
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (account));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_PerformOp (ServiceInterface* self, const gchar* op, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "PerformOp");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (op));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static void service_interface_proxy_UpdateIndicators (ServiceInterface* self, const gchar* stream, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "UpdateIndicators");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (stream));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return;
	}
	g_object_unref (_reply_message);
}


static gchar* service_interface_proxy_GetAvatarPath (ServiceInterface* self, const gchar* url, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp9_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "GetAvatarPath");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (url));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp9_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp9_, NULL);
	g_variant_unref (_tmp9_);
	g_object_unref (_reply_message);
	return _result;
}


static gchar* service_interface_proxy_GetFeatures (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp10_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "GetFeatures");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp10_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp10_, NULL);
	g_variant_unref (_tmp10_);
	g_object_unref (_reply_message);
	return _result;
}


static gchar* service_interface_proxy_GetServices (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp11_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "GetServices");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp11_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp11_, NULL);
	g_variant_unref (_tmp11_);
	g_object_unref (_reply_message);
	return _result;
}


static gchar* service_interface_proxy_GetVersion (ServiceInterface* self, GError** error) {
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar* _result;
	GVariant* _tmp12_;
	G_IO_ERROR;
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "com.Gwibber.Service", "GetVersion");
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_message_set_body (_message, _arguments);
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
	g_object_unref (_message);
	if (!_reply_message) {
		return NULL;
	}
	if (g_dbus_message_to_gerror (_reply_message, error)) {
		g_object_unref (_reply_message);
		return NULL;
	}
	_reply = g_dbus_message_get_body (_reply_message);
	g_variant_iter_init (&_reply_iter, _reply);
	_tmp12_ = g_variant_iter_next_value (&_reply_iter);
	_result = g_variant_dup_string (_tmp12_, NULL);
	g_variant_unref (_tmp12_);
	g_object_unref (_reply_message);
	return _result;
}


static void service_interface_proxy_service_interface_interface_init (ServiceInterfaceIface* iface) {
	iface->Start = service_interface_proxy_Start;
	iface->Quit = service_interface_proxy_Quit;
	iface->Refresh = service_interface_proxy_Refresh;
	iface->SendMessage = service_interface_proxy_SendMessage;
	iface->Send = service_interface_proxy_Send;
	iface->Like = service_interface_proxy_Like;
	iface->Retweet = service_interface_proxy_Retweet;
	iface->PerformOp = service_interface_proxy_PerformOp;
	iface->UpdateIndicators = service_interface_proxy_UpdateIndicators;
	iface->GetAvatarPath = service_interface_proxy_GetAvatarPath;
	iface->GetFeatures = service_interface_proxy_GetFeatures;
	iface->GetServices = service_interface_proxy_GetServices;
	iface->GetVersion = service_interface_proxy_GetVersion;
}


static void _dbus_service_interface_Start (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	service_interface_Start (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Quit (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	service_interface_Quit (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Refresh (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	service_interface_Refresh (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_SendMessage (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* msg = NULL;
	GVariant* _tmp13_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp13_ = g_variant_iter_next_value (&_arguments_iter);
	msg = g_variant_dup_string (_tmp13_, NULL);
	g_variant_unref (_tmp13_);
	service_interface_SendMessage (self, msg, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (msg);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Send (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* msg = NULL;
	GVariant* _tmp14_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp14_ = g_variant_iter_next_value (&_arguments_iter);
	msg = g_variant_dup_string (_tmp14_, NULL);
	g_variant_unref (_tmp14_);
	service_interface_Send (self, msg, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (msg);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Like (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* mid = NULL;
	GVariant* _tmp15_;
	gchar* account = NULL;
	GVariant* _tmp16_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp15_ = g_variant_iter_next_value (&_arguments_iter);
	mid = g_variant_dup_string (_tmp15_, NULL);
	g_variant_unref (_tmp15_);
	_tmp16_ = g_variant_iter_next_value (&_arguments_iter);
	account = g_variant_dup_string (_tmp16_, NULL);
	g_variant_unref (_tmp16_);
	service_interface_Like (self, mid, account, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (mid);
	_g_free0 (account);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_Retweet (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* mid = NULL;
	GVariant* _tmp17_;
	gchar* account = NULL;
	GVariant* _tmp18_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp17_ = g_variant_iter_next_value (&_arguments_iter);
	mid = g_variant_dup_string (_tmp17_, NULL);
	g_variant_unref (_tmp17_);
	_tmp18_ = g_variant_iter_next_value (&_arguments_iter);
	account = g_variant_dup_string (_tmp18_, NULL);
	g_variant_unref (_tmp18_);
	service_interface_Retweet (self, mid, account, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (mid);
	_g_free0 (account);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_PerformOp (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* op = NULL;
	GVariant* _tmp19_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp19_ = g_variant_iter_next_value (&_arguments_iter);
	op = g_variant_dup_string (_tmp19_, NULL);
	g_variant_unref (_tmp19_);
	service_interface_PerformOp (self, op, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (op);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_UpdateIndicators (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* stream = NULL;
	GVariant* _tmp20_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp20_ = g_variant_iter_next_value (&_arguments_iter);
	stream = g_variant_dup_string (_tmp20_, NULL);
	g_variant_unref (_tmp20_);
	service_interface_UpdateIndicators (self, stream, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (stream);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_GetAvatarPath (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	gchar* url = NULL;
	GVariant* _tmp21_;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, parameters);
	_tmp21_ = g_variant_iter_next_value (&_arguments_iter);
	url = g_variant_dup_string (_tmp21_, NULL);
	g_variant_unref (_tmp21_);
	result = service_interface_GetAvatarPath (self, url, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 ( result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	_g_free0 (url);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_GetFeatures (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, parameters);
	result = service_interface_GetFeatures (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 ( result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_GetServices (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, parameters);
	result = service_interface_GetServices (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 ( result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void _dbus_service_interface_GetVersion (ServiceInterface* self, GVariant* parameters, GDBusMethodInvocation* invocation) {
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar* result;
	g_variant_iter_init (&_arguments_iter, parameters);
	result = service_interface_GetVersion (self, &error);
	if (error) {
		g_dbus_method_invocation_return_gerror (invocation, error);
		return;
	}
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_reply_builder, g_variant_new_string (result));
	_g_free0 ( result);
	_reply = g_variant_builder_end (&_reply_builder);
	g_dbus_message_set_body (_reply_message, _reply);
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
	g_object_unref (invocation);
	g_object_unref (_reply_message);
}


static void service_interface_dbus_interface_method_call (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* method_name, GVariant* parameters, GDBusMethodInvocation* invocation, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (method_name, "Start") == 0) {
		_dbus_service_interface_Start (object, parameters, invocation);
	} else if (strcmp (method_name, "Quit") == 0) {
		_dbus_service_interface_Quit (object, parameters, invocation);
	} else if (strcmp (method_name, "Refresh") == 0) {
		_dbus_service_interface_Refresh (object, parameters, invocation);
	} else if (strcmp (method_name, "SendMessage") == 0) {
		_dbus_service_interface_SendMessage (object, parameters, invocation);
	} else if (strcmp (method_name, "Send") == 0) {
		_dbus_service_interface_Send (object, parameters, invocation);
	} else if (strcmp (method_name, "Like") == 0) {
		_dbus_service_interface_Like (object, parameters, invocation);
	} else if (strcmp (method_name, "Retweet") == 0) {
		_dbus_service_interface_Retweet (object, parameters, invocation);
	} else if (strcmp (method_name, "PerformOp") == 0) {
		_dbus_service_interface_PerformOp (object, parameters, invocation);
	} else if (strcmp (method_name, "UpdateIndicators") == 0) {
		_dbus_service_interface_UpdateIndicators (object, parameters, invocation);
	} else if (strcmp (method_name, "GetAvatarPath") == 0) {
		_dbus_service_interface_GetAvatarPath (object, parameters, invocation);
	} else if (strcmp (method_name, "GetFeatures") == 0) {
		_dbus_service_interface_GetFeatures (object, parameters, invocation);
	} else if (strcmp (method_name, "GetServices") == 0) {
		_dbus_service_interface_GetServices (object, parameters, invocation);
	} else if (strcmp (method_name, "GetVersion") == 0) {
		_dbus_service_interface_GetVersion (object, parameters, invocation);
	} else {
		g_object_unref (invocation);
	}
}


static GVariant* service_interface_dbus_interface_get_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return NULL;
}


static gboolean service_interface_dbus_interface_set_property (GDBusConnection* connection, const gchar* sender, const gchar* object_path, const gchar* interface_name, const gchar* property_name, GVariant* value, GError** error, gpointer user_data) {
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}


static void _dbus_service_interface_loading_started (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.Gwibber.Service", "LoadingStarted", _arguments, NULL);
}


static void _dbus_service_interface_loading_complete (GObject* _sender, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.Gwibber.Service", "LoadingComplete", _arguments, NULL);
}


static void _dbus_service_interface_error (GObject* _sender, const gchar* error_str, gpointer* _data) {
	GDBusConnection * _connection;
	const gchar * _path;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	_connection = _data[1];
	_path = _data[2];
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
	g_variant_builder_add_value (&_arguments_builder, g_variant_new_string (error_str));
	_arguments = g_variant_builder_end (&_arguments_builder);
	g_dbus_connection_emit_signal (_connection, NULL, _path, "com.Gwibber.Service", "Error", _arguments, NULL);
}


guint service_interface_register_object (gpointer object, GDBusConnection* connection, const gchar* path, GError** error) {
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_service_interface_dbus_interface_info), &_service_interface_dbus_interface_vtable, data, _service_interface_unregister_object, error);
	if (!result) {
		return 0;
	}
	g_signal_connect (object, "loading-started", (GCallback) _dbus_service_interface_loading_started, data);
	g_signal_connect (object, "loading-complete", (GCallback) _dbus_service_interface_loading_complete, data);
	g_signal_connect (object, "error", (GCallback) _dbus_service_interface_error, data);
	return result;
}


static void _service_interface_unregister_object (gpointer user_data) {
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}


void gwibber_service_service_available (GwibberService* self, gboolean is_up) {
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "is-available", is_up);
}


void gwibber_service_on_loading_started (GwibberService* self) {
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "loading-started");
}


void gwibber_service_on_loading_complete (GwibberService* self) {
	g_return_if_fail (self != NULL);
	g_signal_emit_by_name (self, "loading-complete");
}


static gpointer _json_object_ref0 (gpointer self) {
	return self ? json_object_ref (self) : NULL;
}


void gwibber_service_on_error (GwibberService* self, const gchar* error_str) {
	JsonParser* _tmp0_ = NULL;
	JsonParser* parser;
	JsonNode* _tmp1_ = NULL;
	JsonObject* _tmp2_ = NULL;
	JsonObject* _tmp3_;
	JsonObject* root_object;
	JsonNode* _tmp4_ = NULL;
	JsonObject* _tmp5_ = NULL;
	JsonObject* _tmp6_;
	JsonObject* error_object;
	JsonNode* _tmp7_ = NULL;
	JsonObject* _tmp8_ = NULL;
	JsonObject* _tmp9_;
	JsonObject* account_object;
	JsonNode* _tmp10_ = NULL;
	const gchar* _tmp11_ = NULL;
	gchar* _tmp12_;
	gchar* id;
	JsonNode* _tmp13_ = NULL;
	const gchar* _tmp14_ = NULL;
	gchar* _tmp15_;
	gchar* type;
	JsonNode* _tmp16_ = NULL;
	const gchar* _tmp17_ = NULL;
	gchar* _tmp18_;
	gchar* message;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (error_str != NULL);
	_tmp0_ = json_parser_new ();
	parser = _tmp0_;
	json_parser_load_from_data (parser, error_str, (gssize) (-1), &_inner_error_);
	if (_inner_error_ != NULL) {
		_g_object_unref0 (parser);
		goto __catch11_g_error;
	}
	_tmp1_ = json_parser_get_root (parser);
	_tmp2_ = json_node_get_object (_tmp1_);
	_tmp3_ = _json_object_ref0 (_tmp2_);
	root_object = _tmp3_;
	_tmp4_ = json_object_get_member (root_object, "error");
	_tmp5_ = json_node_get_object (_tmp4_);
	_tmp6_ = _json_object_ref0 (_tmp5_);
	error_object = _tmp6_;
	_tmp7_ = json_object_get_member (error_object, "account");
	_tmp8_ = json_node_get_object (_tmp7_);
	_tmp9_ = _json_object_ref0 (_tmp8_);
	account_object = _tmp9_;
	_tmp10_ = json_object_get_member (account_object, "id");
	_tmp11_ = json_node_get_string (_tmp10_);
	_tmp12_ = g_strdup (_tmp11_);
	id = _tmp12_;
	_tmp13_ = json_object_get_member (error_object, "type");
	_tmp14_ = json_node_get_string (_tmp13_);
	_tmp15_ = g_strdup (_tmp14_);
	type = _tmp15_;
	_tmp16_ = json_object_get_member (error_object, "message");
	_tmp17_ = json_node_get_string (_tmp16_);
	_tmp18_ = g_strdup (_tmp17_);
	message = _tmp18_;
	g_signal_emit_by_name (self, "error", id, type, message);
	_g_free0 (message);
	_g_free0 (type);
	_g_free0 (id);
	_json_object_unref0 (account_object);
	_json_object_unref0 (error_object);
	_json_object_unref0 (root_object);
	_g_object_unref0 (parser);
	goto __finally11;
	__catch11_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("service.vala:145: %s", e->message);
		_g_error_free0 (e);
	}
	__finally11:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


/**
            start:
        */
void gwibber_service_start (GwibberService* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	service_interface_Start (self->priv->service, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch12_g_io_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	goto __finally12;
	__catch12_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("service.vala:157: %s", e->message);
		_g_error_free0 (e);
	}
	__finally12:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


/**
            quit:

            Tells the gwibber service to shutdown.
        */
void gwibber_service_quit (GwibberService* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	service_interface_Quit (self->priv->service, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch13_g_io_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	goto __finally13;
	__catch13_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("service.vala:171: %s", e->message);
		_g_error_free0 (e);
	}
	__finally13:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


/**
            refresh:

            Tells the gwibber service to perform a refresh.
        */
void gwibber_service_refresh (GwibberService* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	service_interface_Refresh (self->priv->service, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch14_g_io_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	goto __finally14;
	__catch14_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("service.vala:185: %s", e->message);
		_g_error_free0 (e);
	}
	__finally14:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


/**
            like:
            @id: the gwibber message id
            @account: the account id
           
            returns a bool
        */
gboolean gwibber_service_like (GwibberService* self, const gchar* id, const gchar* account) {
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* mid;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (id != NULL, FALSE);
	g_return_val_if_fail (account != NULL, FALSE);
	_tmp0_ = g_strdup ("");
	mid = _tmp0_;
	if (id != NULL) {
		gchar* _tmp1_ = NULL;
		gchar* msg;
		gint _tmp2_;
		JsonParser* _tmp3_ = NULL;
		JsonParser* parser;
		JsonNode* _tmp4_ = NULL;
		JsonObject* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		gint _tmp8_;
		_tmp1_ = gwibber_messages_get_message (self->priv->messages, id);
		msg = _tmp1_;
		_tmp2_ = strlen (msg);
		if (_tmp2_ < 1) {
			result = FALSE;
			_g_free0 (msg);
			_g_free0 (mid);
			return result;
		}
		_tmp3_ = json_parser_new ();
		parser = _tmp3_;
		json_parser_load_from_data (parser, msg, (gssize) (-1), &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (parser);
			_g_free0 (msg);
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch15_g_io_error;
			}
			goto __finally15;
		}
		_tmp4_ = json_parser_get_root (parser);
		_tmp5_ = json_node_get_object (_tmp4_);
		_tmp6_ = json_object_get_string_member (_tmp5_, "mid");
		_tmp7_ = g_strdup (_tmp6_);
		_g_free0 (mid);
		mid = _tmp7_;
		_tmp8_ = strlen (mid);
		if (_tmp8_ < 1) {
			result = FALSE;
			_g_object_unref0 (parser);
			_g_free0 (msg);
			_g_free0 (mid);
			return result;
		}
		service_interface_Like (self->priv->service, mid, account, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch16_g_io_error;
			}
			_g_object_unref0 (parser);
			_g_free0 (msg);
			_g_free0 (mid);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		result = TRUE;
		_g_object_unref0 (parser);
		_g_free0 (msg);
		_g_free0 (mid);
		return result;
		goto __finally16;
		__catch16_g_io_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			g_warning ("service.vala:216: %s", e->message);
			result = FALSE;
			_g_error_free0 (e);
			_g_object_unref0 (parser);
			_g_free0 (msg);
			_g_free0 (mid);
			return result;
		}
		__finally16:
		_g_object_unref0 (parser);
		_g_free0 (msg);
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch15_g_io_error;
		}
		_g_object_unref0 (parser);
		_g_free0 (msg);
		_g_free0 (mid);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
		result = FALSE;
		_g_object_unref0 (parser);
		_g_free0 (msg);
		_g_free0 (mid);
		return result;
		_g_object_unref0 (parser);
		_g_free0 (msg);
		goto __finally15;
		__catch15_g_io_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			g_warning ("service.vala:221: %s", e->message);
			result = FALSE;
			_g_error_free0 (e);
			_g_free0 (mid);
			return result;
		}
		__finally15:
		_g_free0 (mid);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = FALSE;
	_g_free0 (mid);
	return result;
}


/**
            retweet:
            @id: the gwibber message id
            @account: the account id
           
            returns a bool
        */
gboolean gwibber_service_retweet (GwibberService* self, const gchar* id, const gchar* account) {
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* mid;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (id != NULL, FALSE);
	g_return_val_if_fail (account != NULL, FALSE);
	_tmp0_ = g_strdup ("");
	mid = _tmp0_;
	if (id != NULL) {
		gchar* _tmp1_ = NULL;
		gchar* msg;
		gint _tmp2_;
		JsonParser* _tmp3_ = NULL;
		JsonParser* parser;
		JsonNode* _tmp4_ = NULL;
		JsonObject* _tmp5_ = NULL;
		const gchar* _tmp6_ = NULL;
		gchar* _tmp7_;
		gint _tmp8_;
		_tmp1_ = gwibber_messages_get_message (self->priv->messages, id);
		msg = _tmp1_;
		_tmp2_ = strlen (msg);
		if (_tmp2_ < 1) {
			result = FALSE;
			_g_free0 (msg);
			_g_free0 (mid);
			return result;
		}
		_tmp3_ = json_parser_new ();
		parser = _tmp3_;
		json_parser_load_from_data (parser, msg, (gssize) (-1), &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (parser);
			_g_free0 (msg);
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch17_g_io_error;
			}
			goto __finally17;
		}
		_tmp4_ = json_parser_get_root (parser);
		_tmp5_ = json_node_get_object (_tmp4_);
		_tmp6_ = json_object_get_string_member (_tmp5_, "mid");
		_tmp7_ = g_strdup (_tmp6_);
		_g_free0 (mid);
		mid = _tmp7_;
		_tmp8_ = strlen (mid);
		if (_tmp8_ < 1) {
			result = FALSE;
			_g_object_unref0 (parser);
			_g_free0 (msg);
			_g_free0 (mid);
			return result;
		}
		service_interface_Retweet (self->priv->service, mid, account, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch18_g_io_error;
			}
			_g_object_unref0 (parser);
			_g_free0 (msg);
			_g_free0 (mid);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		result = TRUE;
		_g_object_unref0 (parser);
		_g_free0 (msg);
		_g_free0 (mid);
		return result;
		goto __finally18;
		__catch18_g_io_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			g_warning ("service.vala:257: %s", e->message);
			result = FALSE;
			_g_error_free0 (e);
			_g_object_unref0 (parser);
			_g_free0 (msg);
			_g_free0 (mid);
			return result;
		}
		__finally18:
		_g_object_unref0 (parser);
		_g_free0 (msg);
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch17_g_io_error;
		}
		_g_object_unref0 (parser);
		_g_free0 (msg);
		_g_free0 (mid);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
		result = FALSE;
		_g_object_unref0 (parser);
		_g_free0 (msg);
		_g_free0 (mid);
		return result;
		_g_object_unref0 (parser);
		_g_free0 (msg);
		goto __finally17;
		__catch17_g_io_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			g_warning ("service.vala:262: %s", e->message);
			result = FALSE;
			_g_error_free0 (e);
			_g_free0 (mid);
			return result;
		}
		__finally17:
		_g_free0 (mid);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = FALSE;
	_g_free0 (mid);
	return result;
}


/**
            send_message:
            @message: The message to post to Gwibber
            @id: The gwibber message id or null
            @action: The action or null
            @account: The account to post from  or null

            Posts a message
        */
static gpointer _json_array_ref0 (gpointer self) {
	return self ? json_array_ref (self) : NULL;
}


gboolean gwibber_service_send_message (GwibberService* self, const gchar* message, const gchar* id, const gchar* action, gchar** accounts, int accounts_length1) {
	gboolean result = FALSE;
	gsize length = 0UL;
	gchar* json = NULL;
	gboolean _tmp0_ = FALSE;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	if (id != NULL) {
		_tmp0_ = action != NULL;
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		gchar* _tmp1_ = NULL;
		gchar* msg;
		gint _tmp2_;
		JsonGenerator* _tmp3_ = NULL;
		JsonGenerator* msg_gen;
		JsonNode* _tmp4_ = NULL;
		JsonNode* root;
		JsonObject* _tmp5_ = NULL;
		JsonObject* object;
		JsonParser* _tmp6_ = NULL;
		JsonParser* parser;
		gsize _tmp16_;
		gchar* _tmp17_ = NULL;
		_tmp1_ = gwibber_messages_get_message (self->priv->messages, id);
		msg = _tmp1_;
		_tmp2_ = strlen (msg);
		if (_tmp2_ < 1) {
			result = FALSE;
			_g_free0 (msg);
			_g_free0 (json);
			return result;
		}
		_tmp3_ = json_generator_new ();
		msg_gen = _tmp3_;
		_tmp4_ = json_node_new (JSON_NODE_OBJECT);
		root = _tmp4_;
		_tmp5_ = json_object_new ();
		object = _tmp5_;
		json_node_set_object (root, object);
		json_generator_set_root (msg_gen, root);
		_tmp6_ = json_parser_new ();
		parser = _tmp6_;
		json_parser_load_from_data (parser, msg, (gssize) (-1), &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (parser);
			_json_object_unref0 (object);
			_json_node_free0 (root);
			_g_object_unref0 (msg_gen);
			_g_free0 (msg);
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch19_g_io_error;
			}
			goto __finally19;
		}
		json_object_set_string_member (object, "message", message);
		if (g_strcmp0 (action, "reply") == 0) {
			JsonNode* _tmp7_ = NULL;
			JsonObject* _tmp8_ = NULL;
			JsonObject* _tmp9_;
			_tmp7_ = json_parser_get_root (parser);
			_tmp8_ = json_node_get_object (_tmp7_);
			_tmp9_ = _json_object_ref0 (_tmp8_);
			json_object_set_object_member (object, "target", _tmp9_);
		}
		if (g_strcmp0 (action, "private") == 0) {
			JsonNode* _tmp10_ = NULL;
			JsonObject* _tmp11_ = NULL;
			JsonObject* _tmp12_;
			_tmp10_ = json_parser_get_root (parser);
			_tmp11_ = json_node_get_object (_tmp10_);
			_tmp12_ = _json_object_ref0 (_tmp11_);
			json_object_set_object_member (object, "private", _tmp12_);
		}
		json_object_set_string_member (object, "action", action);
		if (accounts_length1 > 0) {
			JsonArray* _tmp13_ = NULL;
			JsonArray* acct_array;
			JsonArray* _tmp15_;
			_tmp13_ = json_array_new ();
			acct_array = _tmp13_;
			{
				gchar** a_collection;
				int a_collection_length1;
				int a_it;
				a_collection = accounts;
				a_collection_length1 = accounts_length1;
				for (a_it = 0; a_it < accounts_length1; a_it = a_it + 1) {
					gchar* _tmp14_;
					gchar* a;
					_tmp14_ = g_strdup (a_collection[a_it]);
					a = _tmp14_;
					{
						json_array_add_string_element (acct_array, a);
						_g_free0 (a);
					}
				}
			}
			_tmp15_ = _json_array_ref0 (acct_array);
			json_object_set_array_member (object, "accounts", _tmp15_);
			_json_array_unref0 (acct_array);
		}
		_tmp17_ = json_generator_to_data (msg_gen, &_tmp16_);
		length = _tmp16_;
		_g_free0 (json);
		json = _tmp17_;
		service_interface_Send (self->priv->service, (const gchar*) json, &_inner_error_);
		if (_inner_error_ != NULL) {
			_g_object_unref0 (parser);
			_json_object_unref0 (object);
			_json_node_free0 (root);
			_g_object_unref0 (msg_gen);
			_g_free0 (msg);
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch19_g_io_error;
			}
			_g_object_unref0 (parser);
			_json_object_unref0 (object);
			_json_node_free0 (root);
			_g_object_unref0 (msg_gen);
			_g_free0 (msg);
			_g_free0 (json);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		result = TRUE;
		_g_object_unref0 (parser);
		_json_object_unref0 (object);
		_json_node_free0 (root);
		_g_object_unref0 (msg_gen);
		_g_free0 (msg);
		_g_free0 (json);
		return result;
		_g_object_unref0 (parser);
		_json_object_unref0 (object);
		_json_node_free0 (root);
		_g_object_unref0 (msg_gen);
		_g_free0 (msg);
		goto __finally19;
		__catch19_g_io_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			g_warning ("service.vala:318: %s", e->message);
			result = FALSE;
			_g_error_free0 (e);
			_g_free0 (json);
			return result;
		}
		__finally19:
		_g_free0 (json);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	} else {
		service_interface_SendMessage (self->priv->service, message, &_inner_error_);
		if (_inner_error_ != NULL) {
			if (_inner_error_->domain == G_IO_ERROR) {
				goto __catch20_g_io_error;
			}
			_g_free0 (json);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return FALSE;
		}
		result = TRUE;
		_g_free0 (json);
		return result;
		goto __finally20;
		__catch20_g_io_error:
		{
			GError * e;
			e = _inner_error_;
			_inner_error_ = NULL;
			g_warning ("service.vala:327: %s", e->message);
			result = FALSE;
			_g_error_free0 (e);
			_g_free0 (json);
			return result;
		}
		__finally20:
		_g_free0 (json);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return FALSE;
	}
	result = FALSE;
	_g_free0 (json);
	return result;
}


static void _g_hash_table_remove_all_gdestroy_notify (void* data) {
	g_hash_table_remove_all (data);
}


static void _g_free0_ (gpointer var) {
	var = (g_free (var), NULL);
}


static void _g_list_free__g_free0_ (GList* self) {
	g_list_foreach (self, (GFunc) _g_free0_, NULL);
	g_list_free (self);
}


static gpointer _g_hash_table_ref0 (gpointer self) {
	return self ? g_hash_table_ref (self) : NULL;
}


GHashTable* gwibber_service_services (GwibberService* self) {
	GHashTable* result = NULL;
	GHashTable* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* services;
	JsonParser* _tmp2_ = NULL;
	JsonParser* parser;
	JsonNode* _tmp3_ = NULL;
	JsonObject* _tmp4_ = NULL;
	JsonObject* _tmp5_;
	JsonObject* root_object;
	GList* _tmp6_ = NULL;
	GHashTable* _tmp26_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, _g_hash_table_remove_all_gdestroy_notify);
	_g_hash_table_unref0 (self->priv->services_table);
	self->priv->services_table = _tmp0_;
	_tmp1_ = service_interface_GetServices (self->priv->service, &_inner_error_);
	services = _tmp1_;
	if (_inner_error_ != NULL) {
		goto __catch21_g_error;
	}
	_tmp2_ = json_parser_new ();
	parser = _tmp2_;
	json_parser_load_from_data (parser, services, (gssize) (-1), &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch22_g_error;
	}
	goto __finally22;
	__catch22_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("service.vala:344: %s", e->message);
		result = NULL;
		_g_error_free0 (e);
		_g_object_unref0 (parser);
		_g_free0 (services);
		return result;
	}
	__finally22:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (parser);
		_g_free0 (services);
		goto __catch21_g_error;
	}
	_tmp3_ = json_parser_get_root (parser);
	_tmp4_ = json_node_get_object (_tmp3_);
	_tmp5_ = _json_object_ref0 (_tmp4_);
	root_object = _tmp5_;
	_tmp6_ = json_object_get_members (root_object);
	{
		GList* service_collection;
		GList* service_it;
		service_collection = _tmp6_;
		for (service_it = service_collection; service_it != NULL; service_it = service_it->next) {
			const gchar* service;
			service = (const gchar*) service_it->data;
			{
				GHashTable* _tmp7_ = NULL;
				JsonNode* _tmp8_ = NULL;
				JsonObject* _tmp9_ = NULL;
				JsonObject* _tmp10_;
				JsonObject* services_object;
				GList* _tmp11_ = NULL;
				gchar* _tmp24_;
				GHashTable* _tmp25_;
				_tmp7_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
				_g_hash_table_unref0 (self->priv->service_table);
				self->priv->service_table = _tmp7_;
				_tmp8_ = json_object_get_member (root_object, service);
				_tmp9_ = json_node_get_object (_tmp8_);
				_tmp10_ = _json_object_ref0 (_tmp9_);
				services_object = _tmp10_;
				_tmp11_ = json_object_get_members (services_object);
				{
					GList* member_collection;
					GList* member_it;
					member_collection = _tmp11_;
					for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
						const gchar* member;
						member = (const gchar*) member_it->data;
						{
							JsonNode* _tmp12_ = NULL;
							const gchar* _tmp13_ = NULL;
							_tmp12_ = json_object_get_member (services_object, member);
							_tmp13_ = json_node_type_name (_tmp12_);
							if (g_strcmp0 (_tmp13_, "JsonArray") == 0) {
								JsonArray* _tmp14_ = NULL;
								JsonArray* _tmp15_;
								JsonArray* service_array;
								GList* service_attr_list;
								gchar* _tmp22_;
								GList* _tmp23_ = NULL;
								_tmp14_ = json_object_get_array_member (services_object, member);
								_tmp15_ = _json_array_ref0 (_tmp14_);
								service_array = _tmp15_;
								service_attr_list = NULL;
								{
									gint i;
									i = 0;
									{
										gboolean _tmp16_;
										_tmp16_ = TRUE;
										while (TRUE) {
											guint _tmp17_;
											JsonNode* _tmp18_ = NULL;
											const gchar* _tmp19_ = NULL;
											gchar* _tmp20_;
											gchar* f;
											gchar* _tmp21_;
											if (!_tmp16_) {
												i++;
											}
											_tmp16_ = FALSE;
											_tmp17_ = json_array_get_length (service_array);
											if (!(i < _tmp17_)) {
												break;
											}
											_tmp18_ = json_array_get_element (service_array, (guint) i);
											_tmp19_ = json_node_get_string (_tmp18_);
											_tmp20_ = g_strdup (_tmp19_);
											f = _tmp20_;
											_tmp21_ = g_strdup (f);
											service_attr_list = g_list_append (service_attr_list, _tmp21_);
											_g_free0 (f);
										}
									}
								}
								_tmp22_ = g_strdup (member);
								_tmp23_ = g_list_copy (service_attr_list);
								g_hash_table_insert (self->priv->service_table, _tmp22_, _tmp23_);
								__g_list_free__g_free0_0 (service_attr_list);
								_json_array_unref0 (service_array);
								continue;
							}
						}
					}
					_g_list_free0 (member_collection);
				}
				_tmp24_ = g_strdup (service);
				_tmp25_ = _g_hash_table_ref0 (self->priv->service_table);
				g_hash_table_insert (self->priv->services_table, _tmp24_, _tmp25_);
				_json_object_unref0 (services_object);
			}
		}
		_g_list_free0 (service_collection);
	}
	_tmp26_ = _g_hash_table_ref0 (self->priv->services_table);
	result = _tmp26_;
	_json_object_unref0 (root_object);
	_g_object_unref0 (parser);
	_g_free0 (services);
	return result;
	_json_object_unref0 (root_object);
	_g_object_unref0 (parser);
	_g_free0 (services);
	goto __finally21;
	__catch21_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("service.vala:368: %s", e->message);
		result = NULL;
		_g_error_free0 (e);
		return result;
	}
	__finally21:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


static void _vala_GValue_free (GValue* self) {
	g_value_unset (self);
	g_free (self);
}


static GValue* _g_value_dup (GValue* self) {
	return g_boxed_copy (G_TYPE_VALUE, self);
}


static gpointer __g_value_dup0 (gpointer self) {
	return self ? _g_value_dup (self) : NULL;
}


GHashTable* gwibber_service_features (GwibberService* self) {
	GHashTable* result = NULL;
	GHashTable* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* features;
	JsonParser* _tmp2_ = NULL;
	JsonParser* parser;
	JsonNode* _tmp3_ = NULL;
	JsonObject* _tmp4_ = NULL;
	JsonObject* _tmp5_;
	JsonObject* root_object;
	GList* _tmp6_ = NULL;
	GHashTable* _tmp27_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, _g_hash_table_remove_all_gdestroy_notify);
	_g_hash_table_unref0 (self->priv->features_table);
	self->priv->features_table = _tmp0_;
	_tmp1_ = service_interface_GetFeatures (self->priv->service, &_inner_error_);
	features = _tmp1_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch23_g_io_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp2_ = json_parser_new ();
	parser = _tmp2_;
	json_parser_load_from_data (parser, features, (gssize) (-1), &_inner_error_);
	if (_inner_error_ != NULL) {
		goto __catch24_g_error;
	}
	goto __finally24;
	__catch24_g_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("service.vala:382: %s", e->message);
		result = NULL;
		_g_error_free0 (e);
		_g_object_unref0 (parser);
		_g_free0 (features);
		return result;
	}
	__finally24:
	if (_inner_error_ != NULL) {
		_g_object_unref0 (parser);
		_g_free0 (features);
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch23_g_io_error;
		}
		_g_object_unref0 (parser);
		_g_free0 (features);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp3_ = json_parser_get_root (parser);
	_tmp4_ = json_node_get_object (_tmp3_);
	_tmp5_ = _json_object_ref0 (_tmp4_);
	root_object = _tmp5_;
	_tmp6_ = json_object_get_members (root_object);
	{
		GList* feature_collection;
		GList* feature_it;
		feature_collection = _tmp6_;
		for (feature_it = feature_collection; feature_it != NULL; feature_it = feature_it->next) {
			const gchar* feature;
			feature = (const gchar*) feature_it->data;
			{
				GHashTable* _tmp7_ = NULL;
				JsonNode* _tmp8_ = NULL;
				JsonObject* _tmp9_ = NULL;
				JsonObject* _tmp10_;
				JsonObject* features_object;
				GList* _tmp11_ = NULL;
				gchar* _tmp25_;
				GHashTable* _tmp26_;
				_tmp7_ = g_hash_table_new_full (g_str_hash, g_str_equal, g_free, g_free);
				_g_hash_table_unref0 (self->priv->feature_table);
				self->priv->feature_table = _tmp7_;
				_tmp8_ = json_object_get_member (root_object, feature);
				_tmp9_ = json_node_get_object (_tmp8_);
				_tmp10_ = _json_object_ref0 (_tmp9_);
				features_object = _tmp10_;
				_tmp11_ = json_object_get_members (features_object);
				{
					GList* member_collection;
					GList* member_it;
					member_collection = _tmp11_;
					for (member_it = member_collection; member_it != NULL; member_it = member_it->next) {
						const gchar* member;
						member = (const gchar*) member_it->data;
						{
							GValue* value;
							JsonNode* _tmp12_ = NULL;
							gboolean _tmp13_;
							gchar* _tmp23_;
							GValue* _tmp24_;
							value = NULL;
							_tmp12_ = json_object_get_member (features_object, member);
							_tmp13_ = json_node_is_null (_tmp12_);
							if (_tmp13_) {
								__vala_GValue_free0 (value);
								continue;
							} else {
								JsonNode* _tmp14_ = NULL;
								const gchar* _tmp15_ = NULL;
								_tmp14_ = json_object_get_member (features_object, member);
								_tmp15_ = json_node_type_name (_tmp14_);
								if (g_strcmp0 (_tmp15_, "gboolean") == 0) {
									JsonNode* _tmp16_ = NULL;
									gboolean _tmp17_;
									GValue* _tmp18_ = NULL;
									_tmp16_ = json_object_get_member (features_object, member);
									_tmp17_ = json_node_get_boolean (_tmp16_);
									_tmp18_ = g_new0 (GValue, 1);
									g_value_init (_tmp18_, G_TYPE_BOOLEAN);
									g_value_set_boolean (_tmp18_, _tmp17_);
									__vala_GValue_free0 (value);
									value = _tmp18_;
								} else {
									JsonNode* _tmp19_ = NULL;
									GValue _tmp20_ = {0};
									GValue _tmp21_;
									GValue* _tmp22_;
									_tmp19_ = json_object_get_member (features_object, member);
									json_node_get_value (_tmp19_, &_tmp20_);
									__vala_GValue_free0 (value);
									_tmp21_ = _tmp20_;
									_tmp22_ = __g_value_dup0 (&_tmp21_);
									value = _tmp22_;
									G_IS_VALUE (&_tmp21_) ? (g_value_unset (&_tmp21_), NULL) : NULL;
								}
							}
							_tmp23_ = g_strdup (member);
							_tmp24_ = __g_value_dup0 (value);
							g_hash_table_insert (self->priv->feature_table, _tmp23_, _tmp24_);
							__vala_GValue_free0 (value);
						}
					}
					_g_list_free0 (member_collection);
				}
				_tmp25_ = g_strdup (feature);
				_tmp26_ = _g_hash_table_ref0 (self->priv->feature_table);
				g_hash_table_insert (self->priv->features_table, _tmp25_, _tmp26_);
				_json_object_unref0 (features_object);
			}
		}
		_g_list_free0 (feature_collection);
	}
	_tmp27_ = _g_hash_table_ref0 (self->priv->features_table);
	result = _tmp27_;
	_json_object_unref0 (root_object);
	_g_object_unref0 (parser);
	_g_free0 (features);
	return result;
	_json_object_unref0 (root_object);
	_g_object_unref0 (parser);
	_g_free0 (features);
	goto __finally23;
	__catch23_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("service.vala:404: %s", e->message);
		result = NULL;
		_g_error_free0 (e);
		return result;
	}
	__finally23:
	g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
	g_clear_error (&_inner_error_);
	return NULL;
}


/**
            version:

            Return value: the version of the Gwibber service that is running.
        */
gchar* gwibber_service_version (GwibberService* self) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp0_ = service_interface_GetVersion (self->priv->service, &_inner_error_);
	_tmp1_ = _tmp0_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch25_g_io_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = _tmp1_;
	return result;
	goto __finally25;
	__catch25_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("service.vala:420: %s", e->message);
		_g_error_free0 (e);
	}
	__finally25:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp2_ = g_strdup ("");
	result = _tmp2_;
	return result;
}


/**
            avatar_path:
            @url: url to the avatar to cache

            Return value: path to the cached avatar as a string
        */
static gchar* string_replace (const gchar* self, const gchar* old, const gchar* replacement) {
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	gchar* _tmp1_;
	GRegex* _tmp2_ = NULL;
	GRegex* _tmp3_;
	GRegex* regex;
	gchar* _tmp4_ = NULL;
	gchar* _tmp5_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (old != NULL, NULL);
	g_return_val_if_fail (replacement != NULL, NULL);
	_tmp0_ = g_regex_escape_string (old, -1);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_regex_new (_tmp1_, 0, 0, &_inner_error_);
	_tmp3_ = _tmp2_;
	_g_free0 (_tmp1_);
	regex = _tmp3_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch26_g_regex_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	_tmp4_ = g_regex_replace_literal (regex, self, (gssize) (-1), 0, replacement, 0, &_inner_error_);
	_tmp5_ = _tmp4_;
	if (_inner_error_ != NULL) {
		_g_regex_unref0 (regex);
		if (_inner_error_->domain == G_REGEX_ERROR) {
			goto __catch26_g_regex_error;
		}
		_g_regex_unref0 (regex);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
	result = _tmp5_;
	_g_regex_unref0 (regex);
	return result;
	_g_regex_unref0 (regex);
	goto __finally26;
	__catch26_g_regex_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_assert_not_reached ();
		_g_error_free0 (e);
	}
	__finally26:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return NULL;
	}
}


gchar* gwibber_service_avatar_path (GwibberService* self, const gchar* url, GError** error) {
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* _tmp1_ = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _avatar_cache_image;
	GFile* _tmp5_ = NULL;
	GFile* file;
	gboolean _tmp6_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (url != NULL, NULL);
	_tmp0_ = g_get_user_cache_dir ();
	_tmp1_ = string_replace (url, "/", "");
	_tmp2_ = _tmp1_;
	_tmp3_ = g_build_path (G_DIR_SEPARATOR_S, _tmp0_, "gwibber/avatars", _tmp2_, NULL);
	_tmp4_ = _tmp3_;
	_g_free0 (_tmp2_);
	_avatar_cache_image = _tmp4_;
	_tmp5_ = g_file_new_for_path (_avatar_cache_image);
	file = _tmp5_;
	_tmp6_ = g_file_query_exists (file, NULL);
	if (_tmp6_) {
		result = _avatar_cache_image;
		_g_object_unref0 (file);
		return result;
	} else {
		gchar* _tmp7_ = NULL;
		gchar* _tmp8_;
		_tmp7_ = service_interface_GetAvatarPath (self->priv->service, url, &_inner_error_);
		_tmp8_ = _tmp7_;
		if (_inner_error_ != NULL) {
			g_propagate_error (error, _inner_error_);
			_g_object_unref0 (file);
			_g_free0 (_avatar_cache_image);
			return NULL;
		}
		_g_free0 (_avatar_cache_image);
		_avatar_cache_image = _tmp8_;
	}
	result = _avatar_cache_image;
	_g_object_unref0 (file);
	return result;
}


void gwibber_service_perform (GwibberService* self, const gchar* id, GError** error) {
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (id != NULL);
	_tmp0_ = g_strconcat ("{\"id\": \"", id, NULL);
	_tmp1_ = _tmp0_;
	_tmp2_ = g_strconcat (_tmp1_, "\"}", NULL);
	_tmp3_ = _tmp2_;
	service_interface_PerformOp (self->priv->service, _tmp3_, &_inner_error_);
	_g_free0 (_tmp3_);
	_g_free0 (_tmp1_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch27_g_io_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	goto __finally27;
	__catch27_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("service.vala:447: %s", e->message);
		_g_error_free0 (e);
	}
	__finally27:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		return;
	}
}


void gwibber_service_follow (GwibberService* self, const gchar* account, const gchar* screen_name, gboolean follow, GError** error) {
	gchar* _tmp0_;
	gchar* action;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gchar* _tmp13_;
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	g_return_if_fail (account != NULL);
	g_return_if_fail (screen_name != NULL);
	_tmp0_ = g_strdup ("unfollow");
	action = _tmp0_;
	if (follow) {
		gchar* _tmp1_;
		_tmp1_ = g_strdup ("follow");
		_g_free0 (action);
		action = _tmp1_;
	}
	_tmp2_ = g_strconcat ("{\"account\": \"", account, NULL);
	_tmp3_ = _tmp2_;
	_tmp4_ = g_strconcat (_tmp3_, "\", \"operation\": \"", NULL);
	_tmp5_ = _tmp4_;
	_tmp6_ = g_strconcat (_tmp5_, action, NULL);
	_tmp7_ = _tmp6_;
	_tmp8_ = g_strconcat (_tmp7_, "\", \"args\": {\"screen_name\": \"", NULL);
	_tmp9_ = _tmp8_;
	_tmp10_ = g_strconcat (_tmp9_, screen_name, NULL);
	_tmp11_ = _tmp10_;
	_tmp12_ = g_strconcat (_tmp11_, "\"}}", NULL);
	_tmp13_ = _tmp12_;
	service_interface_PerformOp (self->priv->service, _tmp13_, &_inner_error_);
	_g_free0 (_tmp13_);
	_g_free0 (_tmp11_);
	_g_free0 (_tmp9_);
	_g_free0 (_tmp7_);
	_g_free0 (_tmp5_);
	_g_free0 (_tmp3_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch28_g_io_error;
		}
		_g_free0 (action);
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	goto __finally28;
	__catch28_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("service.vala:461: %s", e->message);
		_g_error_free0 (e);
	}
	__finally28:
	if (_inner_error_ != NULL) {
		g_propagate_error (error, _inner_error_);
		_g_free0 (action);
		return;
	}
	_g_free0 (action);
}


void gwibber_service_update_indicators (GwibberService* self, const gchar* stream) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	if (stream == NULL) {
		stream = "home";
	}
	service_interface_UpdateIndicators (self->priv->service, stream, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch29_g_io_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
	goto __finally29;
	__catch29_g_io_error:
	{
		GError * e;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_warning ("service.vala:472: %s", e->message);
		_g_error_free0 (e);
	}
	__finally29:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


GwibberService* gwibber_service_construct (GType object_type) {
	GwibberService * self = NULL;
	self = (GwibberService*) g_object_new (object_type, NULL);
	return self;
}


GwibberService* gwibber_service_new (void) {
	return gwibber_service_construct (GWIBBER_TYPE_SERVICE);
}


static void g_cclosure_user_marshal_VOID__STRING_STRING_STRING (GClosure * closure, GValue * return_value, guint n_param_values, const GValue * param_values, gpointer invocation_hint, gpointer marshal_data) {
	typedef void (*GMarshalFunc_VOID__STRING_STRING_STRING) (gpointer data1, const char* arg_1, const char* arg_2, const char* arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_STRING callback;
	register GCClosure * cc;
	register gpointer data1, data2;
	cc = (GCClosure *) closure;
	g_return_if_fail (n_param_values == 4);
	if (G_CCLOSURE_SWAP_DATA (closure)) {
		data1 = closure->data;
		data2 = param_values->data[0].v_pointer;
	} else {
		data1 = param_values->data[0].v_pointer;
		data2 = closure->data;
	}
	callback = (GMarshalFunc_VOID__STRING_STRING_STRING) (marshal_data ? marshal_data : cc->callback);
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_string (param_values + 3), data2);
}


static void _gwibber_service_service_available_gwibber_utils_available (GwibberUtils* _sender, gboolean up, gpointer self) {
	gwibber_service_service_available (self, up);
}


static void _gwibber_service_on_loading_started_service_interface_loading_started (ServiceInterface* _sender, gpointer self) {
	gwibber_service_on_loading_started (self);
}


static void _gwibber_service_on_loading_complete_service_interface_loading_complete (ServiceInterface* _sender, gpointer self) {
	gwibber_service_on_loading_complete (self);
}


static void _lambda4_ (const gchar* source, GwibberService* self) {
	g_return_if_fail (source != NULL);
	gwibber_service_on_error (self, source);
}


static void __lambda4__service_interface_error (ServiceInterface* _sender, const gchar* error_str, gpointer self) {
	_lambda4_ (error_str, self);
}


static GObject * gwibber_service_constructor (GType type, guint n_construct_properties, GObjectConstructParam * construct_properties) {
	GObject * obj;
	GObjectClass * parent_class;
	GwibberService * self;
	ServiceInterface* _tmp0_ = NULL;
	ServiceInterface* _tmp1_;
	GwibberUtils* _tmp2_ = NULL;
	GwibberMessages* _tmp5_ = NULL;
	GError * _inner_error_ = NULL;
	parent_class = G_OBJECT_CLASS (gwibber_service_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = GWIBBER_SERVICE (obj);
	_tmp0_ = g_initable_new (TYPE_SERVICE_INTERFACE_PROXY, NULL, &_inner_error_, "g-flags", 0, "g-name", GWIBBER_SERVICE_service_name, "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", GWIBBER_SERVICE_service_path, "g-interface-name", "com.Gwibber.Service", NULL);
	_tmp1_ = (ServiceInterface*) _tmp0_;
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch30_g_io_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_g_object_unref0 (self->priv->service);
	self->priv->service = _tmp1_;
	_tmp2_ = gwibber_utils_new ();
	_g_object_unref0 (self->priv->utils);
	self->priv->utils = _tmp2_;
	gwibber_utils_setup (self->priv->utils, GWIBBER_SERVICE_service_name, &_inner_error_);
	if (_inner_error_ != NULL) {
		if (_inner_error_->domain == G_IO_ERROR) {
			goto __catch30_g_io_error;
		}
		g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	g_signal_connect_object (self->priv->utils, "available", (GCallback) _gwibber_service_service_available_gwibber_utils_available, self, 0);
	g_signal_connect_object (self->priv->service, "loading-started", (GCallback) _gwibber_service_on_loading_started_service_interface_loading_started, self, 0);
	g_signal_connect_object (self->priv->service, "loading-complete", (GCallback) _gwibber_service_on_loading_complete_service_interface_loading_complete, self, 0);
	g_signal_connect_object (self->priv->service, "error", (GCallback) __lambda4__service_interface_error, self, 0);
	goto __finally30;
	__catch30_g_io_error:
	{
		GError * e;
		gchar* _tmp3_;
		gchar* _tmp4_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp3_ = g_strconcat ("Unable to get Gwibber service: ", e->message, NULL);
		_tmp4_ = _tmp3_;
		g_warning ("service.vala:110: %s", _tmp4_);
		_g_free0 (_tmp4_);
		_g_error_free0 (e);
	}
	__finally30:
	if (_inner_error_ != NULL) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
	}
	_tmp5_ = gwibber_messages_new ();
	_g_object_unref0 (self->priv->messages);
	self->priv->messages = _tmp5_;
	return obj;
}


static void gwibber_service_class_init (GwibberServiceClass * klass) {
	gwibber_service_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (GwibberServicePrivate));
	G_OBJECT_CLASS (klass)->constructor = gwibber_service_constructor;
	G_OBJECT_CLASS (klass)->finalize = gwibber_service_finalize;
	/** 
	            Service::is_available:
	            @arg0: The current state
	
	            Emitted when com.Gwibber.Service availability state changes
	        */
	g_signal_new ("is_available", GWIBBER_TYPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__BOOLEAN, G_TYPE_NONE, 1, G_TYPE_BOOLEAN);
	/**
	            Service::loading_started:
	
	            Emitted when an operations starts
	        */
	g_signal_new ("loading_started", GWIBBER_TYPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/**
	            Service::loading_started:
	
	            Emitted when an operations is complete
	        */
	g_signal_new ("loading_complete", GWIBBER_TYPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	/**
	            Service::error:
	            @arg0: String containing the account id
	            @arg1: String containing the error type
	            @arg2: String containing the error message
	
	            Emitted when an error is received from the service
	        */
	g_signal_new ("error", GWIBBER_TYPE_SERVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_STRING, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_STRING);
}


static void gwibber_service_instance_init (GwibberService * self) {
	self->priv = GWIBBER_SERVICE_GET_PRIVATE (self);
}


static void gwibber_service_finalize (GObject* obj) {
	GwibberService * self;
	self = GWIBBER_SERVICE (obj);
	_g_object_unref0 (self->priv->service);
	_g_hash_table_unref0 (self->priv->services_table);
	_g_hash_table_unref0 (self->priv->service_table);
	_g_hash_table_unref0 (self->priv->features_table);
	_g_hash_table_unref0 (self->priv->feature_table);
	_g_object_unref0 (self->priv->utils);
	_g_object_unref0 (self->priv->messages);
	G_OBJECT_CLASS (gwibber_service_parent_class)->finalize (obj);
}


GType gwibber_service_get_type (void) {
	static volatile gsize gwibber_service_type_id__volatile = 0;
	if (g_once_init_enter (&gwibber_service_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (GwibberServiceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) gwibber_service_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (GwibberService), 0, (GInstanceInitFunc) gwibber_service_instance_init, NULL };
		GType gwibber_service_type_id;
		gwibber_service_type_id = g_type_register_static (G_TYPE_OBJECT, "GwibberService", &g_define_type_info, 0);
		g_once_init_leave (&gwibber_service_type_id__volatile, gwibber_service_type_id);
	}
	return gwibber_service_type_id__volatile;
}



